/*
 * Schmid ADC Linux Kernel Modul
 * Copyright (C) 2006  Hanno Rein - University of Tübingen
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * */

#define port_out outb_p
#define port_in inb
static int adc_base;

void adc_setbase (int base)
{
  adc_base = base;
}
 
void allreset()
{
  port_out ( 0, adc_base + 0 );
}

void irqdisab()
{
  port_out ( 0, adc_base + 1 );
}

void irqhalf()
{
  port_out ( 0, adc_base + 2 );
}

void irqfull()
{
  port_out ( 0, adc_base + 3 );
}

void run()
{
  port_out ( 0, adc_base + 4 );
}

void disk()
{
  port_out ( 0, adc_base + 5 );
}

void extgate()
{
  port_out ( 0, adc_base + 6 );
}

void fiforeset()
{
  port_in ( adc_base + 0 );
}

void stop()
{
  port_in ( adc_base + 4 );
}

void disk_off()
{
  port_in ( adc_base + 5 );
}

void extgate_off()
{
  port_in ( adc_base + 6 );
}

/*unsigned char status()
{
  return (unsigned char)port_in ( adc_base + 7 );
}*/
int status()
{
  return port_in ( adc_base + 7 );
}

void route()
{
  port_in ( adc_base + 8 );
}

void route_off()
{
  port_in ( adc_base + 9 );
}

int readnum()
{
  int h,l;

  l = port_in ( adc_base + 13 );
  h = port_in ( adc_base + 14 );
  
  return ( (l & 0x7f) + ((h & 0x7f) << 7) );
}

void allres_release()
{
  port_in ( adc_base + 15 );
}

void dac(int nr, int daten, int akt)
{
  if ( nr < 1 || nr > 4 ) return;

  if ( daten < 0 ) daten = 0;
  if ( daten > 4093) daten = 4093;

  port_out ( daten & 0xff,        nr+0+7+adc_base );
  port_out ( (daten >> 8) & 0x0f, nr+4+7+adc_base );

  if ( akt ) port_out ( 0, adc_base + 7 );
}

int adc()
{
  int data;
  
  data  = port_in ( adc_base + 1 ) << 8;
  data += port_in ( adc_base + 1 );
  data >>= 2;

  return data;
}


